#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _prefs_filters_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"<!-- interface-requires gtk+ 2.8 -->"
"<!-- interface-naming-policy toplevel-contextual -->"
"<widget class=\"GtkWindow\" id=\"window3\">"
"<child>"
"<widget class=\"GtkVBox\" id=\"PrefsFilters\">"
"<property name=\"visible\">True</property>"
"<property name=\"border_width\">12</property>"
"<property name=\"spacing\">18</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox23\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label20\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">0</property>"
"<property name=\"label\" translatable=\"yes\">&lt;b&gt;File filters&lt;/b&gt;</property>"
"<property name=\"use_markup\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkAlignment\" id=\"alignment12\">"
"<property name=\"visible\">True</property>"
"<property name=\"left_padding\">12</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox24\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox25\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkScrolledWindow\" id=\"scrolledwindow1\">"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"hscrollbar_policy\">automatic</property>"
"<property name=\"vscrollbar_policy\">automatic</property>"
"<property name=\"shadow_type\">etched-in</property>"
"<child>"
"<widget class=\"GtkTreeView\" id=\"filter_treeview\">"
"<property name=\"width_request\">400</property>"
"<property name=\"height_request\">200</property>"
"<property name=\"visible\">True</property>"
"<property name=\"reorderable\">True</property>"
"<property name=\"rules_hint\">True</property>"
"<property name=\"enable_search\">False</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkHBox\" id=\"hbox4\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkButton\" id=\"new_filter_setting\">"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"receives_default\">False</property>"
"<property name=\"focus_on_click\">False</property>"
"<child>"
"<widget class=\"GtkImage\" id=\"image1\">"
"<property name=\"visible\">True</property>"
"<property name=\"stock\">gtk-new</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkButton\" id=\"delete_filter_setting\">"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"receives_default\">False</property>"
"<property name=\"focus_on_click\">False</property>"
"<child>"
"<widget class=\"GtkImage\" id=\"image2\">"
"<property name=\"visible\">True</property>"
"<property name=\"stock\">gtk-delete</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkButton\" id=\"filter_setting_down\">"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"receives_default\">False</property>"
"<child>"
"<widget class=\"GtkImage\" id=\"image3\">"
"<property name=\"visible\">True</property>"
"<property name=\"stock\">gtk-go-down</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">2</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkButton\" id=\"filter_setting_up\">"
"<property name=\"visible\">True</property>"
"<property name=\"can_focus\">False</property>"
"<property name=\"receives_default\">False</property>"
"<child>"
"<widget class=\"GtkImage\" id=\"image4\">"
"<property name=\"visible\">True</property>"
"<property name=\"stock\">gtk-go-up</property>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">3</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</glade-interface>"

;

typedef struct PrefsFiltersXml PrefsFiltersXml;

struct PrefsFiltersXml {
    MooGladeXML *xml;

    GtkVBox *PrefsFilters;
    GtkTreeView *filter_treeview;
    GtkButton *new_filter_setting;
    GtkButton *delete_filter_setting;
    GtkButton *filter_setting_down;
    GtkButton *filter_setting_up;

};

static void
_prefs_filters_xml_free (PrefsFiltersXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static PrefsFiltersXml *
prefs_filters_xml_get (gpointer widget)
{
    return (PrefsFiltersXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_prefs_filters_xml_finish_build (PrefsFiltersXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->PrefsFilters = (GtkVBox*) moo_glade_xml_get_widget (xml->xml, "PrefsFilters");
    g_return_val_if_fail (xml->PrefsFilters != NULL, FALSE);
    xml->filter_treeview = (GtkTreeView*) moo_glade_xml_get_widget (xml->xml, "filter_treeview");
    g_return_val_if_fail (xml->filter_treeview != NULL, FALSE);
    xml->new_filter_setting = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "new_filter_setting");
    g_return_val_if_fail (xml->new_filter_setting != NULL, FALSE);
    xml->delete_filter_setting = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "delete_filter_setting");
    g_return_val_if_fail (xml->delete_filter_setting != NULL, FALSE);
    xml->filter_setting_down = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "filter_setting_down");
    g_return_val_if_fail (xml->filter_setting_down != NULL, FALSE);
    xml->filter_setting_up = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "filter_setting_up");
    g_return_val_if_fail (xml->filter_setting_up != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->PrefsFilters), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _prefs_filters_xml_free);
    return TRUE;
}

static gboolean
prefs_filters_xml_build (PrefsFiltersXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _prefs_filters_xml_glade_xml, -1, "PrefsFilters", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_filters_xml_finish_build (xml);
}

static gboolean
prefs_filters_xml_fill (PrefsFiltersXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _prefs_filters_xml_glade_xml, -1, "PrefsFilters", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_filters_xml_finish_build (xml);
}

static PrefsFiltersXml *
prefs_filters_xml_new_empty (void)
{
    PrefsFiltersXml *xml = g_new0 (PrefsFiltersXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static PrefsFiltersXml *
prefs_filters_xml_new (void)
{
    PrefsFiltersXml *xml = prefs_filters_xml_new_empty ();
    if (!prefs_filters_xml_build (xml))
    {
        _prefs_filters_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static PrefsFiltersXml *
prefs_filters_xml_new_with_root (GtkWidget *root)
{
    PrefsFiltersXml *xml = prefs_filters_xml_new_empty ();
    if (!prefs_filters_xml_fill (xml, root))
    {
        _prefs_filters_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
