#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _moo_find_box_xml_glade_xml[] =
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
"<glade-interface>"
"<!-- interface-requires gtk+ 2.6 -->"
"<!-- interface-naming-policy toplevel-contextual -->"
"<widget class=\"GtkDialog\" id=\"dialog1\">"
"<property name=\"title\">Find</property>"
"<property name=\"window_position\">center-on-parent</property>"
"<property name=\"destroy_with_parent\">True</property>"
"<property name=\"type_hint\">dialog</property>"
"<child internal-child=\"vbox\">"
"<widget class=\"GtkVBox\" id=\"dialog-vbox1\">"
"<property name=\"visible\">True</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"MooFindBox\">"
"<property name=\"visible\">True</property>"
"<property name=\"border_width\">3</property>"
"<property name=\"spacing\">3</property>"
"<child>"
"<widget class=\"GtkFrame\" id=\"find_frame\">"
"<property name=\"visible\">True</property>"
"<property name=\"label_xalign\">0</property>"
"<child>"
"<widget class=\"GtkAlignment\" id=\"alignment1\">"
"<property name=\"visible\">True</property>"
"<property name=\"top_padding\">6</property>"
"<property name=\"bottom_padding\">6</property>"
"<property name=\"left_padding\">6</property>"
"<property name=\"right_padding\">6</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox2\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">3</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label3\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">0</property>"
"<property name=\"label\" translatable=\"yes\">_Text to find:</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"mnemonic_widget\">search_entry:MooHistoryCombo</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkEntry\" id=\"search_entry:MooHistoryCombo\">"
"<property name=\"visible\">True</property>"
"<property name=\"activates_default\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkHBox\" id=\"hbox1\">"
"<property name=\"visible\">True</property>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"regex\">"
"<property name=\"label\" translatable=\"yes\">Regular e_xpression</property>"
"<property name=\"visible\">True</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">2</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</child>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label1\">"
"<property name=\"visible\">True</property>"
"<property name=\"label\" translatable=\"yes\">Find</property>"
"</widget>"
"<packing>"
"<property name=\"type\">label_item</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkFrame\" id=\"replace_frame\">"
"<property name=\"visible\">True</property>"
"<property name=\"label_xalign\">0</property>"
"<child>"
"<widget class=\"GtkAlignment\" id=\"alignment3\">"
"<property name=\"visible\">True</property>"
"<property name=\"top_padding\">6</property>"
"<property name=\"bottom_padding\">6</property>"
"<property name=\"left_padding\">6</property>"
"<property name=\"right_padding\">6</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox3\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">3</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label4\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">0</property>"
"<property name=\"label\" translatable=\"yes\">_Replacement text:</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"mnemonic_widget\">replace_entry:MooHistoryCombo</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkEntry\" id=\"replace_entry:MooHistoryCombo\">"
"<property name=\"visible\">True</property>"
"<property name=\"activates_default\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkHBox\" id=\"hbox2\">"
"<property name=\"visible\">True</property>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"repl_literal\">"
"<property name=\"label\" translatable=\"yes\">_Literal replacement</property>"
"<property name=\"visible\">True</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">2</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</child>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label5\">"
"<property name=\"visible\">True</property>"
"<property name=\"label\" translatable=\"yes\">Replace With</property>"
"</widget>"
"<packing>"
"<property name=\"type\">label_item</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkFrame\" id=\"options_frame\">"
"<property name=\"visible\">True</property>"
"<property name=\"label_xalign\">0</property>"
"<child>"
"<widget class=\"GtkAlignment\" id=\"alignment2\">"
"<property name=\"visible\">True</property>"
"<property name=\"top_padding\">3</property>"
"<property name=\"bottom_padding\">3</property>"
"<property name=\"left_padding\">3</property>"
"<property name=\"right_padding\">3</property>"
"<child>"
"<widget class=\"GtkTable\" id=\"table1\">"
"<property name=\"visible\">True</property>"
"<property name=\"n_rows\">3</property>"
"<property name=\"n_columns\">2</property>"
"<property name=\"column_spacing\">3</property>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"dont_prompt\">"
"<property name=\"label\" translatable=\"yes\">Don't _prompt on replace</property>"
"<property name=\"visible\">True</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"left_attach\">1</property>"
"<property name=\"right_attach\">2</property>"
"<property name=\"top_attach\">2</property>"
"<property name=\"bottom_attach\">3</property>"
"<property name=\"x_options\">GTK_FILL</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"backwards\">"
"<property name=\"label\" translatable=\"yes\">Find _backwards</property>"
"<property name=\"visible\">True</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"left_attach\">1</property>"
"<property name=\"right_attach\">2</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"case_sensitive\">"
"<property name=\"label\" translatable=\"yes\">Case _sensitive</property>"
"<property name=\"visible\">True</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"selected\">"
"<property name=\"label\" translatable=\"yes\">S_elected text</property>"
"<property name=\"visible\">True</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"left_attach\">1</property>"
"<property name=\"right_attach\">2</property>"
"<property name=\"top_attach\">1</property>"
"<property name=\"bottom_attach\">2</property>"
"<property name=\"x_options\">GTK_FILL</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"from_cursor\">"
"<property name=\"label\" translatable=\"yes\">From c_ursor</property>"
"<property name=\"visible\">True</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"top_attach\">2</property>"
"<property name=\"bottom_attach\">3</property>"
"<property name=\"x_options\">GTK_FILL</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkCheckButton\" id=\"whole_words\">"
"<property name=\"label\" translatable=\"yes\">_Whole words only</property>"
"<property name=\"visible\">True</property>"
"<property name=\"use_underline\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"<property name=\"draw_indicator\">True</property>"
"</widget>"
"<packing>"
"<property name=\"top_attach\">1</property>"
"<property name=\"bottom_attach\">2</property>"
"<property name=\"x_options\">GTK_FILL</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</child>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label2\">"
"<property name=\"visible\">True</property>"
"<property name=\"label\" translatable=\"yes\">Options</property>"
"</widget>"
"<packing>"
"<property name=\"type\">label_item</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">2</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child internal-child=\"action_area\">"
"<widget class=\"GtkHButtonBox\" id=\"dialog-action_area1\">"
"<property name=\"visible\">True</property>"
"<property name=\"layout_style\">end</property>"
"<child>"
"<widget class=\"GtkButton\" id=\"cancel_btn\">"
"<property name=\"label\">gtk-cancel</property>"
"<property name=\"response_id\">-6</property>"
"<property name=\"visible\">True</property>"
"<property name=\"can_default\">True</property>"
"<property name=\"use_stock\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkButton\" id=\"ok_btn\">"
"<property name=\"label\">gtk-find</property>"
"<property name=\"response_id\">-5</property>"
"<property name=\"visible\">True</property>"
"<property name=\"can_default\">True</property>"
"<property name=\"has_default\">True</property>"
"<property name=\"use_stock\">True</property>"
"<property name=\"focus_on_click\">False</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"pack_type\">end</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</glade-interface>"

;

typedef struct MooFindBoxXml MooFindBoxXml;

struct MooFindBoxXml {
    MooGladeXML *xml;

    GtkVBox *MooFindBox;
    GtkFrame *find_frame;
    MooHistoryCombo *search_entry;
    GtkCheckButton *regex;
    GtkFrame *replace_frame;
    MooHistoryCombo *replace_entry;
    GtkCheckButton *repl_literal;
    GtkFrame *options_frame;
    GtkCheckButton *dont_prompt;
    GtkCheckButton *backwards;
    GtkCheckButton *case_sensitive;
    GtkCheckButton *selected;
    GtkCheckButton *from_cursor;
    GtkCheckButton *whole_words;

};

static void
_moo_find_box_xml_free (MooFindBoxXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static MooFindBoxXml *
moo_find_box_xml_get (gpointer widget)
{
    return (MooFindBoxXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_moo_find_box_xml_finish_build (MooFindBoxXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->MooFindBox = (GtkVBox*) moo_glade_xml_get_widget (xml->xml, "MooFindBox");
    g_return_val_if_fail (xml->MooFindBox != NULL, FALSE);
    xml->find_frame = (GtkFrame*) moo_glade_xml_get_widget (xml->xml, "find_frame");
    g_return_val_if_fail (xml->find_frame != NULL, FALSE);
    xml->search_entry = (MooHistoryCombo*) moo_glade_xml_get_widget (xml->xml, "search_entry:MooHistoryCombo");
    g_return_val_if_fail (xml->search_entry != NULL, FALSE);
    xml->regex = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "regex");
    g_return_val_if_fail (xml->regex != NULL, FALSE);
    xml->replace_frame = (GtkFrame*) moo_glade_xml_get_widget (xml->xml, "replace_frame");
    g_return_val_if_fail (xml->replace_frame != NULL, FALSE);
    xml->replace_entry = (MooHistoryCombo*) moo_glade_xml_get_widget (xml->xml, "replace_entry:MooHistoryCombo");
    g_return_val_if_fail (xml->replace_entry != NULL, FALSE);
    xml->repl_literal = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "repl_literal");
    g_return_val_if_fail (xml->repl_literal != NULL, FALSE);
    xml->options_frame = (GtkFrame*) moo_glade_xml_get_widget (xml->xml, "options_frame");
    g_return_val_if_fail (xml->options_frame != NULL, FALSE);
    xml->dont_prompt = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "dont_prompt");
    g_return_val_if_fail (xml->dont_prompt != NULL, FALSE);
    xml->backwards = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "backwards");
    g_return_val_if_fail (xml->backwards != NULL, FALSE);
    xml->case_sensitive = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "case_sensitive");
    g_return_val_if_fail (xml->case_sensitive != NULL, FALSE);
    xml->selected = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "selected");
    g_return_val_if_fail (xml->selected != NULL, FALSE);
    xml->from_cursor = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "from_cursor");
    g_return_val_if_fail (xml->from_cursor != NULL, FALSE);
    xml->whole_words = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "whole_words");
    g_return_val_if_fail (xml->whole_words != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->MooFindBox), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _moo_find_box_xml_free);
    return TRUE;
}

static gboolean
moo_find_box_xml_build (MooFindBoxXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _moo_find_box_xml_glade_xml, -1, "MooFindBox", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _moo_find_box_xml_finish_build (xml);
}

static gboolean
moo_find_box_xml_fill (MooFindBoxXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _moo_find_box_xml_glade_xml, -1, "MooFindBox", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _moo_find_box_xml_finish_build (xml);
}

static MooFindBoxXml *
moo_find_box_xml_new_empty (void)
{
    MooFindBoxXml *xml = g_new0 (MooFindBoxXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static MooFindBoxXml *
moo_find_box_xml_new (void)
{
    MooFindBoxXml *xml = moo_find_box_xml_new_empty ();
    if (!moo_find_box_xml_build (xml))
    {
        _moo_find_box_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static MooFindBoxXml *
moo_find_box_xml_new_with_root (GtkWidget *root)
{
    MooFindBoxXml *xml = moo_find_box_xml_new_empty ();
    if (!moo_find_box_xml_fill (xml, root))
    {
        _moo_find_box_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
