#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _try_encoding_dialog_xml_glade_xml[] =
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
"<glade-interface>"
"<!-- interface-requires gtk+ 2.6 -->"
"<!-- interface-naming-policy toplevel-contextual -->"
"<widget class=\"GtkDialog\" id=\"TryEncodingDialog\">"
"<property name=\"border_width\">5</property>"
"<property name=\"type_hint\">normal</property>"
"<child internal-child=\"vbox\">"
"<widget class=\"GtkVBox\" id=\"dialog-vbox2\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">2</property>"
"<child>"
"<widget class=\"GtkHBox\" id=\"hbox1\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkImage\" id=\"image1\">"
"<property name=\"visible\">True</property>"
"<property name=\"yalign\">0</property>"
"<property name=\"xpad\">6</property>"
"<property name=\"ypad\">6</property>"
"<property name=\"stock\">gtk-dialog-error</property>"
"<property name=\"icon-size\">6</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox1\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label_primary\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">0</property>"
"<property name=\"use_markup\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label_secondary\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">0</property>"
"<property name=\"wrap\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkComboBoxEntry\" id=\"encoding_combo\">"
"<property name=\"visible\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">2</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child internal-child=\"action_area\">"
"<widget class=\"GtkHButtonBox\" id=\"dialog-action_area2\">"
"<property name=\"visible\">True</property>"
"<property name=\"layout_style\">end</property>"
"<child>"
"<placeholder/>"
"</child>"
"<child>"
"<placeholder/>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"pack_type\">end</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</glade-interface>"

;

typedef struct TryEncodingDialogXml TryEncodingDialogXml;

struct TryEncodingDialogXml {
    MooGladeXML *xml;

    GtkDialog *TryEncodingDialog;
    GtkLabel *label_primary;
    GtkLabel *label_secondary;
    GtkComboBoxEntry *encoding_combo;

};

static void
_try_encoding_dialog_xml_free (TryEncodingDialogXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static TryEncodingDialogXml *
try_encoding_dialog_xml_get (gpointer widget)
{
    return (TryEncodingDialogXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_try_encoding_dialog_xml_finish_build (TryEncodingDialogXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->TryEncodingDialog = (GtkDialog*) moo_glade_xml_get_widget (xml->xml, "TryEncodingDialog");
    g_return_val_if_fail (xml->TryEncodingDialog != NULL, FALSE);
    xml->label_primary = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "label_primary");
    g_return_val_if_fail (xml->label_primary != NULL, FALSE);
    xml->label_secondary = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "label_secondary");
    g_return_val_if_fail (xml->label_secondary != NULL, FALSE);
    xml->encoding_combo = (GtkComboBoxEntry*) moo_glade_xml_get_widget (xml->xml, "encoding_combo");
    g_return_val_if_fail (xml->encoding_combo != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->TryEncodingDialog), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _try_encoding_dialog_xml_free);
    return TRUE;
}

static gboolean
try_encoding_dialog_xml_build (TryEncodingDialogXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _try_encoding_dialog_xml_glade_xml, -1, "TryEncodingDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _try_encoding_dialog_xml_finish_build (xml);
}

static gboolean
try_encoding_dialog_xml_fill (TryEncodingDialogXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _try_encoding_dialog_xml_glade_xml, -1, "TryEncodingDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _try_encoding_dialog_xml_finish_build (xml);
}

static TryEncodingDialogXml *
try_encoding_dialog_xml_new_empty (void)
{
    TryEncodingDialogXml *xml = g_new0 (TryEncodingDialogXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static TryEncodingDialogXml *
try_encoding_dialog_xml_new (void)
{
    TryEncodingDialogXml *xml = try_encoding_dialog_xml_new_empty ();
    if (!try_encoding_dialog_xml_build (xml))
    {
        _try_encoding_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static TryEncodingDialogXml *
try_encoding_dialog_xml_new_with_root (GtkWidget *root)
{
    TryEncodingDialogXml *xml = try_encoding_dialog_xml_new_empty ();
    if (!try_encoding_dialog_xml_fill (xml, root))
    {
        _try_encoding_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
